Subject: Re: pppoe and receive checksum offload

From: Stephen Hemminger <[email-masked]>
Date: Mon, 28 Feb 2005 09:12:52 -0800

>>Someone reported a problem with skge hardware receive checksumming and PPPOE
>>> but it looks like a generic problem.  Since PPPOE adds additional header
>>> bytes the hardware computed checksum will be wrong.  
>>> 
>>> Not sure if this is correct, but shouldn't pppoe be doing the following:
> 
> 
> Changing or expanding the link level headers should only mess
> up the hw checksum if you are using CHECKSUM_HW, is that what
> your skge driver is using?

The hardware doesn't appear to actually decode the packet, it just
has the ability to compute data sum of packet starting at an arbitrary
byte offset. This matched the description of CHECKSUM_HW so
that is what I used.

The original sk98lin attempted to receive hardware checksumming
but never actually turned it on.